Subject: Re: [bug#28226] Build go with gccgo

From: Catonano <[email-masked]>
Date: Tue, 12 Sep 2017 14:54:33 +0200

2017-09-12 12:44 GMT+02:00 Efraim Flashner <[email-masked]>:

> On Tue, Sep 12, 2017 at 11:59:31AM +0200, Catonano wrote:
> > 2017-08-24 22:51 GMT+02:00 Efraim Flashner <[email-masked]>:
> >
> > > I need some help testing this on x86_64, I did all the building and
> > > testing on aarch64. It turns out there's a known issues in the cgo
> > > implementation that causes the test suite to fail on aarch64. With this
> > > patch set I was able to build gccgo@7 -> [email-masked] -> lfam's syncthing.
> > >
> >
> > I can't apply these patches
> >
> > ~/projects/guix$ git am
> > 0001-gnu-custom-gcc-Add-flag-to-optionally-not-remove-con.patch
> > Applying: gnu: custom-gcc: Add flag to optionally not remove conflicting
> > files.
> >
> > ~/projects/guix$ git am 0002-gnu-Add-gccgo-7.patch
> > Applying: gnu: Add gccgo@7.
> > error: patch non riuscita: gnu/packages/gcc.scm:414
> > error: gnu/packages/gcc.scm: la patch non può essere applicata
> > Patch failed at 0001 gnu: Add gccgo@7.
> > The copy of the patch that failed is found in: .git/rebase-apply/patch
> > When you have resolved this problem, run "git am --continue".
> > If you prefer to skip this patch, run "git am --skip" instead.
> > To restore the original branch and stop patching, run "git am --abort".
> >
> >
> > I don't know what these patches do, I was just trying to apply them in
> > order (1, 2, 3)
> >
> > Should I follow a different order ?
> >
> > I would have attempted to build this thing
> >
> > I git pulled on master right now ( 12 september) and created a branch for
> > thhese patches and git am'ed there
>
> I've reattached the patches, seems they don't apply cleanly anymore
>
>

This is the last part of the build log
Do you need the whole log ?

[...]
##### Testing without libgcc.
ok      crypto/x509    0.662s
ok      net    0.005s
ok      os/user    0.007s

##### internal linking of -buildmode=pie
ok      reflect    0.680s

##### sync -cpu=10
ok      sync    0.325s

##### ../misc/cgo/stdio

##### ../misc/cgo/life

##### ../misc/cgo/test
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/test    6.050s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/test    6.250s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/test    5.827s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/testtls    0.002s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/testtls    0.009s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/testtls    0.001s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/nocgo    0.002s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/nocgo    0.002s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/nocgo    0.002s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/test    4.177s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/testtls    0.016s
PASS
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/nocgo    0.010s

##### Testing race detector
ok      runtime/race    4.613s
ok      flag    1.031s
ok      os    1.051s
ok      os/exec    1.028s [no tests to run]
PASS
scatter = 0x610b10
hello from C
sqrt is: 0
ok      _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/test    4.708s
ok      flag    1.031s
ok      os/exec    1.012s [no tests to run]

##### ../misc/cgo/testgodefs

##### ../misc/cgo/testso

##### ../misc/cgo/testsovar

##### ../misc/cgo/testcarchive
PASS

##### ../misc/cgo/testcshared
ok

##### ../misc/cgo/testshared
--- FAIL: TestGoPathShlibGccgo (0.13s)
    shared_test.go:65: executing go install
-installsuffix=5577006791947779410 -compiler=gccgo -buildmode=shared
-linkshared depBase failed exit status 2:
        # /tmp/guix-build-go-1.9.drv-0/go-build895598556/libdepBase.so
        gccgo: error: unrecognized command line option
‘-rpath=/gnu/store/41938jrv1xlhawdskyhz45vvbzaic60v-gccgo-7.2.0/lib’
--- FAIL: TestTwoGopathShlibsGccgo (0.08s)
    shared_test.go:65: executing go install
-installsuffix=5577006791947779410 -compiler=gccgo -buildmode=shared
-linkshared depBase failed exit status 2:
        # /tmp/guix-build-go-1.9.drv-0/go-build013538701/libdepBase.so
        gccgo: error: unrecognized command line option
‘-rpath=/gnu/store/41938jrv1xlhawdskyhz45vvbzaic60v-gccgo-7.2.0/lib’
FAIL
exit status 1
FAIL    _/tmp/guix-build-go-1.9.drv-0/go/misc/cgo/testshared    19.432s
2017/09/12 12:45:19 Failed: exit status 1

##### ../misc/cgo/testplugin
PASS
something

##### ../misc/cgo/testasan

##### ../misc/cgo/testsanitizers
./test.bash: line 18: sysctl: command not found
skipping msan tests: gcc -fsanitize=memory not supported

##### ../misc/cgo/errors
skipped due to earlier error

##### ../misc/cgo/testsigfwd
skipped due to earlier error

##### ../test/bench/go1
skipped due to earlier error

##### ../test
skipped due to earlier error

##### API check
skipped due to earlier error
2017/09/12 12:45:37 FAILED
phase `build' failed after 382.6 seconds
builder for `/gnu/store/4k6ag9n2r2239r9cjjkyq76pa9n0bw94-go-1.9.drv' failed
with exit code 1
@ build-failed /gnu/store/4k6ag9n2r2239r9cjjkyq76pa9n0bw94-go-1.9.drv - 1
builder for `/gnu/store/4k6ag9n2r2239r9cjjkyq76pa9n0bw94-go-1.9.drv' failed
with exit code 1
guix build: error: build failed: build of
`/gnu/store/4k6ag9n2r2239r9cjjkyq76pa9n0bw94-go-1.9.drv' failed
catonano@xps ~/projects/guix [env]$